aggregateData(columnName: string, aggregateType: SlicerAggregateType, range?: ISlicerRangeConditional): number
SlicerAggregateType provides 11 aggregate function types as follows:
AVERAGE
COUNT
COUNTA
MAX
MIN
PRODUCT
STDEV
STDEVP
SUBTOTAL
SUM
VARS
VARP
You can also create your own data aggregation slicer as shown in the following code.
window.onload = function () {
var spread = new GC.Spread.Sheets.Workbook(document.getElementById("ss"));
initSpread(spread);
};
function initSpread(spread) {
var sd = data;
if (sd && sd[0].sheets) {
if (!spread) {
return;
}
spread.suspendPaint();
spread.fromJSON(sd[0]);
spread.resumePaint();
addAggregationSlicer(spread);
}
}
function addAggregationSlicer(spread) {
var sheet = spread.getActiveSheet();
var table = sheet.tables.find(0, 0);
var dataSource = new AggregationSlicerData(sheet, table, 1, 5);
var timeSlicer = new TimelineSlicer(dataSource, "Date");
var slicerTimeLine = document.getElementById('slicer_Timeline');
slicerTimeLine.innerHTML = '<p style="padding:2px 10px; background-color:#F4F8EB">Click on the items in the chart slicer to filter by</p>';
slicerTimeLine.appendChild(timeSlicer.getDOMElement());
slicerTimeLine.appendChild(timeSlicer.getHeader());
timeSlicer.attachEventsToHeader();
}
var AggregationSlicerData_YEAR = 0, AggregationSlicerData_MONTH = 1, AggregationSlicerData_OTHER = 2;
function AggregationSlicerData(sheet, table, dataStartIndex, dataEndIndex) {
GC.Spread.Sheets.Slicers.TableSlicerData.call(this, table);
this.dateGroup = {years: []};
this.listeners = [];
this.dataStartIndex = dataStartIndex;
this.dataEndIndex = dataEndIndex;
this.sheet = sheet;
}
AggregationSlicerData.prototype = GC.Spread.Sheets.Slicers.TableSlicerData.prototype;
AggregationSlicerData.prototype.constructor = AggregationSlicerData;
AggregationSlicerData.prototype.buildDateGroups = function (columnName) {
var allDates = this.getExclusiveData(columnName);
var dateGroup = this.dateGroup;
for (var dateIndex = 0; dateIndex < allDates.length; dateIndex++) {
var value = this.getOneRecordValue(columnName, dateIndex);
var date = new Date(allDates[dateIndex]);
var year = date.getFullYear(), month = date.getMonth(), day = date.getDate();
var yearGroup = dateGroup[year];
if (!yearGroup) {
yearGroup = dateGroup[year] = {value: 0, monthes: [], indexes: []};
dateGroup.years.push(year);
}
var monthGroup = yearGroup[month];
if (!monthGroup) {
monthGroup = yearGroup[month] = {value: 0, days: [], indexes: []};
yearGroup.monthes.push(month);
}
var dayGroup = monthGroup[day];
if (!dayGroup) {
dayGroup = monthGroup[day] = {value: 0};
monthGroup.days.push(day);
}
yearGroup.value += value;
monthGroup.value += value;
dayGroup.value += value;
yearGroup.indexes.push(dateIndex);
monthGroup.indexes.push(dateIndex);
}
};
AggregationSlicerData.prototype.getOneRecordValue = function (columnName, exclusiveIndex) {
var columnIndexes = this.getRowIndexes(columnName, exclusiveIndex);
var sheet = this.sheet, table = this.getTable(), dataRangeInSheet = table.dataRange(), startRow = dataRangeInSheet.row, startCol = dataRangeInSheet.col, result = 0;
for (var r = 0; r < columnIndexes.length; r++) {
for (var c = this.dataStartIndex; c <= this.dataEndIndex; c++) {
var value = sheet.getValue(columnIndexes[r] + startRow, c + startCol);
result += value;
}
}
return result;
};
AggregationSlicerData.prototype.getDatasByYear = function () {
var dateGroup = this.dateGroup;
var years = dateGroup.years;
var result = [];
for (var i = 0; i < years.length; i++) {
var year = years[i];
result.push({title: year, value: dateGroup[year].value});
}
return result;
};
AggregationSlicerData.prototype.getMonthDatasByYear = function (year) {
var dateGroup = this.dateGroup;
var yearGroup = dateGroup[year], monthes = yearGroup.monthes;
var result = [];
for (var i = 0; i < monthes.length; i++) {
var month = monthes[i];
result.push({title: month, value: yearGroup[month].value});
}
return result;
};
AggregationSlicerData.prototype.getDayDatasByMonth = function (year, month) {
var dateGroup = this.dateGroup;
var yearGroup = dateGroup[year], monthGroup = yearGroup[month], days = monthGroup.days;
var result = [];
for (var i = 0; i < days.length; i++) {
var day = days[i];
result.push({title: day, value: monthGroup[day].value});
}
return result;
};
AggregationSlicerData.prototype.filterOnYear = function (columnName, year) {
var yearGroup = this.dateGroup[year];
var indexes = yearGroup.indexes;
this.mode = AggregationSlicerData_YEAR;
this.doFilter(columnName, {exclusiveRowIndexes: indexes});
this.mode = AggregationSlicerData_OTHER;
};
AggregationSlicerData.prototype.filterOnMonth = function (columnName, year, month) {
var yearGroup = this.dateGroup[year];
var monthGroup = yearGroup[month];
var indexes = monthGroup.indexes;
this.mode = AggregationSlicerData_MONTH;
this.doFilter(columnName, {exclusiveRowIndexes: indexes});
this.mode = AggregationSlicerData_OTHER;
};
AggregationSlicerData.prototype.onFiltered = function (filteredIndexes, isPreview) {
for (var i = 0; i < this.listeners.length; i++) {
this.listeners[i].onFiltered({columnIndexes: filteredIndexes, isPreview: isPreview, mode: this.mode});
}
};
AggregationSlicerData.prototype.attachListener = function (listener) {
this.listeners.push(listener);
};
AggregationSlicerData.prototype.dettachListener = function (listener) {
for (var i = 0; i < this.listeners.length; i++) {
if (this.listeners[i] === listener) {
this.listeners.splice(i);
break;
}
}
};
AggregationSlicerData.prototype.clearFilter = function (columnName) {
this.doUnfilter(columnName);
};
var Bar = (function () {
function Bar(title, value, x, width, disable) {
if (disable === void 0) {disable = false;}
this.disable = false;
this.title = title;
this.value = value;
this.disable = disable;
this.x = x;
this.width = width;
}
return Bar;
})();
var root = null;
var header = null;
function TimelineSlicer(slicerData, columnName) {
this._canExpand = true;
this.mode = AggregationSlicerData_YEAR;
slicerData.buildDateGroups(columnName);
this.aggregationData = slicerData;
this.slicerData = slicerData;
this.columnName = columnName;
this.data = slicerData.getData(columnName);
this.exclusiveDatas = slicerData.getExclusiveData(columnName);
this.slicerData.attachListener(this);
this.onDataLoaded();
}
TimelineSlicer.prototype.constructor = TimelineSlicer;
TimelineSlicer.prototype.getDOMElement = function () {
return root;
}
TimelineSlicer.prototype.getHeader = function () {
return header;
}
TimelineSlicer.prototype.onDataLoaded = function () {
var self = this;
self.initHeader();
var div = document.createElement('div');
div.style.width = '100%';
div.style.height = '100%';
div.innerHTML = '<canvas width=250 height=200></canvas>'
var canvas = div.firstChild;
this.canvas = canvas;
root = div;
canvas.onmousemove = function (event) {
var bar = self.hitTest(event.offsetX, event.offsetY);
if (bar !== self.hoverBar) {
self.hoverBar = bar;
self.paint();
}
};
canvas.onmouseout = function () {
self.hoverBar = null;
self.paint();
};
canvas.onclick = function (event) {
var bar = self.hitTest(event.offsetX, event.offsetY);
if (!bar) {
return;
}
if (bar !== self.selectedBar) {
if (!self.canExpand()) {
self.selectedBar = bar;
if (self.mode === AggregationSlicerData_YEAR) {
self.selectedYear = parseInt(bar.title, 10);
self.aggregationData.filterOnYear(self.columnName, self.selectedYear);
}
else if (self.mode === AggregationSlicerData_MONTH) {
self.selectedMonth = parseInt(bar.title, 10);
self.aggregationData.filterOnMonth(self.columnName, self.selectedYear, self.selectedMonth);
}
}
else {
if (self.mode === AggregationSlicerData_YEAR) {
self.selectedBar = null;
self.selectedYear = parseInt(bar.title, 10);
self.mode = AggregationSlicerData_MONTH;
self.bars = self.getBars();
self.aggregationData.filterOnYear(self.columnName, self.selectedYear);
}
}
self.paint();
}
};
this.bars = this.getBars();
self.paint();
};
TimelineSlicer.prototype.initHeader = function () {
var headerContainer = document.createElement('div');
headerContainer.innerHTML = '<p class="desc">Check this to allow the user to expand the year into months.</p>'
+ '<input id="canExpand" type="checkbox"/>'
+ '<label for="canExpand">Allow Year to Month Aggregation</label>'
+ '<input id="return" type="button" value="Change back to year aggregation">';
header = headerContainer;
};
TimelineSlicer.prototype.attachEventsToHeader = function () {
var canExpand = document.getElementById("canExpand");
canExpand.checked=this._canExpand;
canExpand.onchange = function (sender, args) {
self._canExpand = canExpand.checked;
};
var returnButton = document.getElementById("return");
returnButton.style.width = "100%";
var self = this;
returnButton.onclick=function () {
if (self.mode === AggregationSlicerData_YEAR) {
return;
}
self.mode = AggregationSlicerData_YEAR;
self.selectedBar = null;
self.bars = self.getBars();
self.paint();
self.aggregationData.doUnfilter(self.columnName);
}
};
TimelineSlicer.prototype.hitTest = function (x, y) {
var bars = this.bars;
for (var i = 0; i < bars.length; i++) {
var bar = bars[i];
if (x >= bar.x && x < bar.x + bar.width) {
return bar;
}
}
return null;
};
TimelineSlicer.prototype.paint = function () {
var context = this.canvas.getContext("2d");
var bars = this.bars;
var topValue = this.getTopValue(bars);
var width = this.canvas.width;
var height = this.canvas.height;
var ruleHeight = 20, borderWidth = 2;
var maxBarHeight = height - ruleHeight;
context.clearRect(0, 0, width, height);
for (var i = 0; i < bars.length; i++) {
var bar = bars[i];
if (bar === this.selectedBar) {
context.fillStyle = "#1b1b1b";
context.fillRect(bar.x - borderWidth * 2, 0, bar.width + 4 * borderWidth, height);
context.fillStyle = "#E1E1E1";
context.fillRect(bar.x - borderWidth, 0 + borderWidth, bar.width + 2 * borderWidth, height - 2 * borderWidth);
}
else if (bar === this.hoverBar) {
context.fillStyle = "#C1C1C1";
context.fillRect(bar.x - borderWidth, 0 + borderWidth, bar.width + 2 * borderWidth, height - 2 * borderWidth);
}
if (this.selectedBar && bar !== this.selectedBar) {
context.fillStyle = "#003c4d";
}
else {
context.fillStyle = "#0096c0";
}
context.fillText(this.getTitle(bar.title), bar.x + borderWidth * 2, height - borderWidth * 4);
var barHeight = maxBarHeight * bar.value / topValue;
context.fillRect(bar.x, maxBarHeight - barHeight, bar.width, barHeight);
}
};
TimelineSlicer.prototype.getTitle = function (title) {
var monthes = ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"];
if (this.mode === AggregationSlicerData_MONTH) {
return monthes[parseInt(title, 10)];
}
return title;
};
TimelineSlicer.prototype.getTopValue = function (bars) {
var max = bars[0].value;
for (var i = 1; i < bars.length; i++) {
max = max < bars[i].value ? bars[i].value : max;
}
var base = 1;
while (max / base >= 10) {
base *= 10;
}
var head = max / base;
return Math.ceil(head) * base;
};
TimelineSlicer.prototype.currentSelection = function () {
if (this.canExpand()) {
return -1;
}
switch (this.mode) {
case AggregationSlicerData_YEAR:
return this.selectedYear;
case AggregationSlicerData_MONTH:
return this.selectedMonth;
}
return -1;
};
TimelineSlicer.prototype.getBars = function () {
var result = [];
var datas;
if (this.mode === AggregationSlicerData_YEAR) {
datas = this.aggregationData.getDatasByYear();
}
else if (this.mode === AggregationSlicerData_MONTH) {
datas = this.aggregationData.getMonthDatasByYear(this.selectedYear);
}
else {
datas = this.aggregationData.getDayDatasByMonth(this.selectedYear, this.selectedMonth);
}
var length = datas.length;
var barLayout = this.getBarLayout(length);
var current = this.currentSelection();
for (var i = 0; i < length; i++) {
result.push(new Bar(datas[i].title + "", datas[i].value, this.getX(barLayout, length, i), barLayout.width, false));
}
return result;
};
TimelineSlicer.prototype.getX = function (layout, count, index) {
if (count <= 12) {
return layout.margin * (index + 1) + layout.width * index;
}
else {
var current = this.currentSelection();
if (current < 5) {
return layout.margin * (index + 1) + layout.width * index;
}
else {
var displayIndex = index - 5;
if (displayIndex < 0) {
return -100;
}
return layout.margin * (displayIndex + 1) + layout.width * displayIndex - layout.width / 2;
}
}
};
TimelineSlicer.prototype.canExpand = function () {
return this._canExpand && this.mode !== AggregationSlicerData_MONTH;
};
TimelineSlicer.prototype.getBarLayout = function (count) {
var fullWidth = this.canvas.width, margin, width;
var fold = 5;
if (count <= 12) {
margin = fullWidth / ((fold + 1) * count + 1);
width = fold * margin;
}
else {
margin = fullWidth / ((fold + 1) * 10 + 1);
width = fold * margin;
}
return {margin: margin, width: width};
};
TimelineSlicer.prototype.onFiltered = function (data) {
};
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<script src="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets/dist/gc.spread.sheets.all.min.js" type="text/javascript"></script>
<script src="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets-shapes/dist/gc.spread.sheets.shapes.min.js" type="text/javascript"></script>
<script src="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets-slicers/dist/gc.spread.sheets.slicers.min.js" type="text/javascript"></script>
<script src="$DEMOROOT$/spread/source/js/license.js" type="text/javascript"></script>
<script src="$DEMOROOT$/spread/source/data/aggregationSlicer.js" type="text/javascript"></script>
<script src="app.js" type="text/javascript"></script>
<link rel="stylesheet" type="text/css" href="styles.css">
</head>
<body>
<div class="sample-tutorial">
<div id="ss" class="sample-spreadsheets"></div>
<div class="options-container">
<div id="slicer_Timeline"></div>
</div>
</div>
</body>
</html>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 280px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.option-row {
font-size: 14px;
padding: 5px;
margin-top: 10px;
}
input[type=button] {
padding: 4px 6px;
box-sizing: border-box;
margin: 6px 0;
display: block;
}
#slicer_Timeline{
padding-bottom: 20px;
}
.desc {
padding:2px 10px;
background-color:#F4F8EB;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}

aggregateData(columnName: string, aggregateType: SlicerAggregateType, range?: ISlicerRangeConditional): number
SlicerAggregateType provides 11 aggregate function types as follows:
AVERAGE
COUNT
COUNTA
MAX
MIN
PRODUCT
STDEV
STDEVP
SUBTOTAL
SUM
VARS
VARP
You can also create your own data aggregation slicer as shown in the following code.
import { Component, NgModule, enableProdMode } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { SpreadSheetsModule } from '@mescius/spread-sheets-angular';
import GC from '@mescius/spread-sheets';
import "@mescius/spread-sheets-slicers";
import './styles.css';
function addAggregationSlicer(spread: GC.Spread.Sheets.Workbook) {
let sheet = spread.getActiveSheet();
let table = sheet.tables.find(0, 0);
let dataSource = new AggregationSlicerData(sheet, table, 1, 5);
let timeSlicer = new TimelineSlicer(dataSource, "Date");
let slicerTimeLine = document.getElementById('slicer_Timeline');
slicerTimeLine.innerHTML = '<p style="padding:2px 10px; background-color:#F4F8EB">Click on the items in the chart slicer to filter by</p>';
slicerTimeLine.appendChild(timeSlicer.getDOMElement());
slicerTimeLine.appendChild(timeSlicer.getHeader());
timeSlicer.attachEventsToHeader();
}
const AggregationSlicerData_YEAR = 0, AggregationSlicerData_MONTH = 1, AggregationSlicerData_OTHER = 2;
class AggregationSlicerData extends GC.Spread.Sheets.Slicers.TableSlicerData {
dateGroup: any;
listeners: any[];
dataStartIndex: number;
dataEndIndex: number;
sheet: GC.Spread.Sheets.Worksheet;
mode: number;
constructor (sheet: GC.Spread.Sheets.Worksheet, table: GC.Spread.Sheets.Tables.Table, dataStartIndex: number, dataEndIndex: number) {
super(table);
this.dateGroup = {years: []};
this.listeners = [];
this.dataStartIndex = dataStartIndex;
this.dataEndIndex = dataEndIndex;
this.sheet = sheet;
}
buildDateGroups (columnName: string) {
let allDates = this.getExclusiveData(columnName);
let dateGroup = this.dateGroup;
for (let dateIndex = 0; dateIndex < allDates.length; dateIndex++) {
let value = this.getOneRecordValue(columnName, dateIndex);
let date = new Date(allDates[dateIndex]);
let year = date.getFullYear(), month = date.getMonth(), day = date.getDate();
let yearGroup = dateGroup[year];
if (!yearGroup) {
yearGroup = dateGroup[year] = {value: 0, monthes: [], indexes: []};
dateGroup.years.push(year);
}
let monthGroup = yearGroup[month];
if (!monthGroup) {
monthGroup = yearGroup[month] = {value: 0, days: [], indexes: []};
yearGroup.monthes.push(month);
}
let dayGroup = monthGroup[day];
if (!dayGroup) {
dayGroup = monthGroup[day] = {value: 0};
monthGroup.days.push(day);
}
yearGroup.value += value;
monthGroup.value += value;
dayGroup.value += value;
yearGroup.indexes.push(dateIndex);
monthGroup.indexes.push(dateIndex);
}
}
getOneRecordValue (columnName: string, exclusiveIndex: number) {
let columnIndexes = this.getRowIndexes(columnName, exclusiveIndex);
let sheet = this.sheet, table = this.getTable(), dataRangeInSheet = table.dataRange(), startRow = dataRangeInSheet.row, startCol = dataRangeInSheet.col, result = 0;
for (let r = 0; r < columnIndexes.length; r++) {
for (let c = this.dataStartIndex; c <= this.dataEndIndex; c++) {
let value = sheet.getValue(columnIndexes[r] + startRow, c + startCol);
result += value;
}
}
return result;
}
getDatasByYear () {
let dateGroup = this.dateGroup;
let years = dateGroup.years;
let result = [];
for (let i = 0; i < years.length; i++) {
let year = years[i];
result.push({title: year, value: dateGroup[year].value});
}
return result;
}
getMonthDatasByYear (year: number) {
let dateGroup = this.dateGroup;
let yearGroup = dateGroup[year], monthes = yearGroup.monthes;
let result = [];
for (let i = 0; i < monthes.length; i++) {
let month = monthes[i];
result.push({title: month, value: yearGroup[month].value});
}
return result;
}
getDayDatasByMonth (year: number, month: number) {
let dateGroup = this.dateGroup;
let yearGroup = dateGroup[year], monthGroup = yearGroup[month], days = monthGroup.days;
let result = [];
for (let i = 0; i < days.length; i++) {
let day = days[i];
result.push({title: day, value: monthGroup[day].value});
}
return result;
}
filterOnYear (columnName: string, year: number) {
let yearGroup = this.dateGroup[year];
let indexes = yearGroup.indexes;
this.mode = AggregationSlicerData_YEAR;
this.doFilter(columnName, {exclusiveRowIndexes: indexes});
this.mode = AggregationSlicerData_OTHER;
}
filterOnMonth (columnName: string, year: number, month: number) {
let yearGroup = this.dateGroup[year];
let monthGroup = yearGroup[month];
let indexes = monthGroup.indexes;
this.mode = AggregationSlicerData_MONTH;
this.doFilter(columnName, {exclusiveRowIndexes: indexes});
this.mode = AggregationSlicerData_OTHER;
}
onFiltered (filteredIndexes: number[], isPreview: boolean) {
for (let i = 0; i < this.listeners.length; i++) {
this.listeners[i].onFiltered({columnIndexes: filteredIndexes, isPreview: isPreview, mode: this.mode});
}
}
attachListener (listener: any) {
this.listeners.push(listener);
}
dettachListener (listener: any) {
for (let i = 0; i < this.listeners.length; i++) {
if (this.listeners[i] === listener) {
this.listeners.splice(i);
break;
}
}
}
clearFilter (columnName: string) {
this.doUnfilter(columnName);
}
}
class Bar {
disable: boolean;
title: string;
value: any;
x: number;
width: number;
constructor (title: string, value: any, x: number, width: number, disable: boolean) {
if (disable === void 0) {disable = false;}
this.disable = false;
this.title = title;
this.value = value;
this.disable = disable;
this.x = x;
this.width = width;
}
}
class TimelineSlicer {
root: HTMLElement;
header: HTMLElement;
_canExpand: boolean;
mode: number;
aggregationData: AggregationSlicerData;
slicerData: AggregationSlicerData;
columnName: string;
data: any;
exclusiveDatas: any[];
canvas: any;
hoverBar: HTMLElement;
selectedBar: HTMLElement;
selectedYear: number;
selectedMonth: number;
bars: Bar[];
constructor (slicerData: AggregationSlicerData, columnName: string) {
this.root = null;
this.header = null;
this._canExpand = true;
this.mode = AggregationSlicerData_YEAR;
slicerData.buildDateGroups(columnName);
this.aggregationData = slicerData;
this.slicerData = slicerData;
this.columnName = columnName;
this.data = slicerData.getData(columnName);
this.exclusiveDatas = slicerData.getExclusiveData(columnName);
this.slicerData.attachListener(this);
this.onDataLoaded();
}
getDOMElement () {
return this.root;
}
getHeader () {
return this.header;
}
onDataLoaded () {
let self = this;
self.initHeader();
let div = document.createElement('div');
div.style.width = '100%';
div.style.height = '100%';
div.innerHTML = '<canvas width=250 height=200></canvas>'
let canvas: any = div.firstChild;
this.canvas = canvas;
this.root = div;
canvas.onmousemove = function (event: any) {
let bar = self.hitTest(event.offsetX, event.offsetY);
if (bar !== self.hoverBar) {
self.hoverBar = bar;
self.paint();
}
};
canvas.onmouseout = function () {
self.hoverBar = null;
self.paint();
};
canvas.onclick = function (event: any) {
let bar = self.hitTest(event.offsetX, event.offsetY);
if (!bar) {
return;
}
if (bar !== self.selectedBar) {
if (!self.canExpand()) {
self.selectedBar = bar;
if (self.mode === AggregationSlicerData_YEAR) {
self.selectedYear = parseInt(bar.title, 10);
self.aggregationData.filterOnYear(self.columnName, self.selectedYear);
}
else if (self.mode === AggregationSlicerData_MONTH) {
self.selectedMonth = parseInt(bar.title, 10);
self.aggregationData.filterOnMonth(self.columnName, self.selectedYear, self.selectedMonth);
}
}
else {
if (self.mode === AggregationSlicerData_YEAR) {
self.selectedBar = null;
self.selectedYear = parseInt(bar.title, 10);
self.mode = AggregationSlicerData_MONTH;
self.bars = self.getBars();
self.aggregationData.filterOnYear(self.columnName, self.selectedYear);
}
}
self.paint();
}
};
this.bars = this.getBars();
self.paint();
}
initHeader () {
let headerContainer = document.createElement('div');
headerContainer.innerHTML = '<p class="desc">Check this to allow the user to expand the year into months.</p>'
+ '<input id="canExpand" type="checkbox"/>'
+ '<label for="canExpand">Allow Year to Month Aggregation</label>'
+ '<input id="return" type="button" value="Change back to year aggregation">';
this.header = headerContainer;
}
attachEventsToHeader () {
let canExpand: any = document.getElementById("canExpand");
canExpand.checked=this._canExpand;
canExpand.onchange = function () {
self._canExpand = canExpand.checked;
};
let returnButton = document.getElementById("return");
returnButton.style.width = "100%";
let self = this;
returnButton.onclick=function () {
if (self.mode === AggregationSlicerData_YEAR) {
return;
}
self.mode = AggregationSlicerData_YEAR;
self.selectedBar = null;
self.bars = self.getBars();
self.paint();
self.aggregationData.doUnfilter(self.columnName);
}
}
hitTest (x: number, y: number) {
let bars = this.bars;
for (let i = 0; i < bars.length; i++) {
let bar = bars[i];
if (x >= bar.x && x < bar.x + bar.width) {
return bar;
}
}
return null;
}
paint () {
let context = this.canvas.getContext("2d");
let bars = this.bars;
let topValue = this.getTopValue(bars);
let width = this.canvas.width;
let height = this.canvas.height;
let ruleHeight = 20, borderWidth = 2;
let maxBarHeight = height - ruleHeight;
context.clearRect(0, 0, width, height);
for (let i = 0; i < bars.length; i++) {
let bar = bars[i];
if (bar === this.selectedBar) {
context.fillStyle = "#1b1b1b";
context.fillRect(bar.x - borderWidth * 2, 0, bar.width + 4 * borderWidth, height);
context.fillStyle = "#E1E1E1";
context.fillRect(bar.x - borderWidth, 0 + borderWidth, bar.width + 2 * borderWidth, height - 2 * borderWidth);
}
else if (bar === this.hoverBar) {
context.fillStyle = "#C1C1C1";
context.fillRect(bar.x - borderWidth, 0 + borderWidth, bar.width + 2 * borderWidth, height - 2 * borderWidth);
}
if (this.selectedBar && bar !== this.selectedBar) {
context.fillStyle = "#003c4d";
}
else {
context.fillStyle = "#0096c0";
}
context.fillText(this.getTitle(bar.title), bar.x + borderWidth * 2, height - borderWidth * 4);
let barHeight = maxBarHeight * bar.value / topValue;
context.fillRect(bar.x, maxBarHeight - barHeight, bar.width, barHeight);
}
}
getTitle (title: string) {
let monthes = ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"];
if (this.mode === AggregationSlicerData_MONTH) {
return monthes[parseInt(title, 10)];
}
return title;
}
getTopValue (bars: Bar[]) {
let max = bars[0].value;
for (let i = 1; i < bars.length; i++) {
max = max < bars[i].value ? bars[i].value : max;
}
let base = 1;
while (max / base >= 10) {
base *= 10;
}
let head = max / base;
return Math.ceil(head) * base;
}
currentSelection () {
if (this.canExpand()) {
return -1;
}
switch (this.mode) {
case AggregationSlicerData_YEAR:
return this.selectedYear;
case AggregationSlicerData_MONTH:
return this.selectedMonth;
}
return -1;
}
getBars () {
let result = [];
let datas;
if (this.mode === AggregationSlicerData_YEAR) {
datas = this.aggregationData.getDatasByYear();
}
else if (this.mode === AggregationSlicerData_MONTH) {
datas = this.aggregationData.getMonthDatasByYear(this.selectedYear);
}
else {
datas = this.aggregationData.getDayDatasByMonth(this.selectedYear, this.selectedMonth);
}
let length = datas.length;
let barLayout = this.getBarLayout(length);
let current = this.currentSelection();
for (let i = 0; i < length; i++) {
result.push(new Bar(datas[i].title + "", datas[i].value, this.getX(barLayout, length, i), barLayout.width, false));
}
return result;
}
getX (layout: any, count: number, index: number) {
if (count <= 12) {
return layout.margin * (index + 1) + layout.width * index;
}
else {
let current = this.currentSelection();
if (current < 5) {
return layout.margin * (index + 1) + layout.width * index;
}
else {
let displayIndex = index - 5;
if (displayIndex < 0) {
return -100;
}
return layout.margin * (displayIndex + 1) + layout.width * displayIndex - layout.width / 2;
}
}
}
canExpand () {
return this._canExpand && this.mode !== AggregationSlicerData_MONTH;
}
getBarLayout (count: number) {
let fullWidth = this.canvas.width, margin, width;
let fold = 5;
if (count <= 12) {
margin = fullWidth / ((fold + 1) * count + 1);
width = fold * margin;
}
else {
margin = fullWidth / ((fold + 1) * 10 + 1);
width = fold * margin;
}
return {margin: margin, width: width};
}
onFiltered () {
};
}
@Component({
selector: 'app-component',
templateUrl: 'src/app.component.html'
})
export class AppComponent {
hostStyle = {
width: 'calc(100% - 280px)',
height: '100%',
overflow: 'hidden',
float: 'left'
};
constructor() {}
initSpread($event: any) {
let spread = $event.spread;
let sd = data;
if (sd && sd[0].sheets) {
if (!spread) {
return;
}
spread.suspendPaint();
spread.fromJSON(sd[0]);
spread.resumePaint();
addAggregationSlicer(spread);
}
}
}
@NgModule({
imports: [BrowserModule, SpreadSheetsModule],
declarations: [AppComponent],
exports: [AppComponent],
bootstrap: [AppComponent]
})
export class AppModule {}
enableProdMode();
// Bootstrap application with hash style navigation and global services.
platformBrowserDynamic().bootstrapModule(AppModule);
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/angular/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<script src="$DEMOROOT$/spread/source/data/aggregationSlicer.js" type="text/javascript"></script>
<!-- Polyfills -->
<script src="$DEMOROOT$/en/angular/node_modules/zone.js/fesm2015/zone.min.js"></script>
<!-- SystemJS -->
<script src="$DEMOROOT$/en/angular/node_modules/systemjs/dist/system.js"></script>
<script src="systemjs.config.js"></script>
<script>
// workaround to load 'rxjs/operators' from the rxjs bundle
System.import('rxjs').then(function (m) {
System.import('@angular/compiler');
System.set(SystemJS.resolveSync('rxjs/operators'), System.newModule(m.operators));
System.import('$DEMOROOT$/en/lib/angular/license.ts');
System.import('./src/app.component');
});
</script>
</head>
<body>
<app-component></app-component>
</body>
</html>
<div class="sample-tutorial">
<gc-spread-sheets [hostStyle]="hostStyle" (workbookInitialized)="initSpread($event)">
</gc-spread-sheets>
<div class="options-container">
<div id="slicer_Timeline"></div>
</div>
</div>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 280px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.option-row {
font-size: 14px;
padding: 5px;
margin-top: 10px;
}
input[type=button] {
padding: 4px 6px;
box-sizing: border-box;
margin: 6px 0;
display: block;
}
#slicer_Timeline{
padding-bottom: 20px;
}
.desc {
padding:2px 10px;
background-color:#F4F8EB;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
(function (global) {
System.config({
transpiler: 'ts',
typescriptOptions: {
tsconfig: true
},
meta: {
'typescript': {
"exports": "ts"
},
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/',
'cdn:': 'https://cdn.mescius.io/demoapps/packages/spreadjs/19.1.2-master-2026-06-10-2131/'
},
// map tells the System loader where to look for things
map: {
'zone': 'npm:zone.js/fesm2015/zone.min.js',
'rxjs': 'npm:rxjs/dist/bundles/rxjs.umd.min.js',
'@angular/core': 'npm:@angular/core/fesm2022',
'@angular/common': 'npm:@angular/common/fesm2022/common.mjs',
'@angular/compiler': 'npm:@angular/compiler/fesm2022/compiler.mjs',
'@angular/platform-browser': 'npm:@angular/platform-browser/fesm2022/platform-browser.mjs',
'@angular/platform-browser-dynamic': 'npm:@angular/platform-browser-dynamic/fesm2022/platform-browser-dynamic.mjs',
'@angular/common/http': 'npm:@angular/common/fesm2022/http.mjs',
'@angular/router': 'npm:@angular/router/fesm2022/router.mjs',
'@angular/forms': 'npm:@angular/forms/fesm2022/forms.mjs',
'jszip': 'npm:jszip/dist/jszip.min.js',
'typescript': 'npm:typescript/lib/typescript.js',
'ts': './plugin.js',
'tslib':'npm:tslib/tslib.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js',
'@mescius/spread-sheets': 'cdn:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-shapes': 'cdn:@mescius/spread-sheets-shapes/index.js',
'@mescius/spread-sheets-slicers': 'cdn:@mescius/spread-sheets-slicers/index.js',
'@mescius/spread-sheets-angular': 'cdn:@mescius/spread-sheets-angular/fesm2020/mescius-spread-sheets-angular.mjs',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'ts'
},
rxjs: {
defaultExtension: 'js'
},
"node_modules": {
defaultExtension: 'js'
},
"node_modules/@angular": {
defaultExtension: 'mjs'
},
"@mescius/spread-sheets-angular": {
defaultExtension: 'mjs'
},
'@angular/core': {
defaultExtension: 'mjs',
main: 'core.mjs'
}
}
});
})(this);

aggregateData(columnName: string, aggregateType: SlicerAggregateType, range?: ISlicerRangeConditional): number
SlicerAggregateType provides 11 aggregate function types as follows:
AVERAGE
COUNT
COUNTA
MAX
MIN
PRODUCT
STDEV
STDEVP
SUBTOTAL
SUM
VARS
VARP
You can also create your own data aggregation slicer as shown in the following code.
import * as React from 'react';
import { createRoot } from 'react-dom/client';
import './styles.css';
import { AppFunc } from './app-func';
// import { App } from './app-class';
// 1. Functional Component sample
createRoot(document.getElementById('app')).render(<AppFunc />);
// 2. Class Component sample
// createRoot(document.getElementById('app')).render(<App />);
import * as React from 'react';
import GC from '@mescius/spread-sheets';
import { SpreadSheets } from '@mescius/spread-sheets-react';
import "@mescius/spread-sheets-slicers";
function _getElementById(id) {
return document.getElementById(id);
}
function addAggregationSlicer(spread) {
let sheet = spread.getActiveSheet();
let table = sheet.tables.find(0, 0);
let dataSource = new AggregationSlicerData(sheet, table, 1, 5);
let timeSlicer = new TimelineSlicer(dataSource, "Date");
let slicerTimeLine = _getElementById('slicer_Timeline');
slicerTimeLine.innerHTML = '<p style="padding:2px 10px; background-color:#F4F8EB">Click on the items in the chart slicer to filter by</p>';
slicerTimeLine.appendChild(timeSlicer.getDOMElement());
slicerTimeLine.appendChild(timeSlicer.getHeader());
timeSlicer.attachEventsToHeader();
}
const AggregationSlicerData_YEAR = 0, AggregationSlicerData_MONTH = 1, AggregationSlicerData_OTHER = 2;
class AggregationSlicerData extends GC.Spread.Sheets.Slicers.TableSlicerData {
constructor(sheet, table, dataStartIndex, dataEndIndex) {
super(table);
this.dateGroup = { years: [] };
this.listeners = [];
this.dataStartIndex = dataStartIndex;
this.dataEndIndex = dataEndIndex;
this.sheet = sheet;
}
buildDateGroups(columnName) {
let allDates = this.getExclusiveData(columnName);
let dateGroup = this.dateGroup;
for (let dateIndex = 0; dateIndex < allDates.length; dateIndex++) {
let value = this.getOneRecordValue(columnName, dateIndex);
let date = new Date(allDates[dateIndex]);
let year = date.getFullYear(), month = date.getMonth(), day = date.getDate();
let yearGroup = dateGroup[year];
if (!yearGroup) {
yearGroup = dateGroup[year] = { value: 0, monthes: [], indexes: [] };
dateGroup.years.push(year);
}
let monthGroup = yearGroup[month];
if (!monthGroup) {
monthGroup = yearGroup[month] = { value: 0, days: [], indexes: [] };
yearGroup.monthes.push(month);
}
let dayGroup = monthGroup[day];
if (!dayGroup) {
dayGroup = monthGroup[day] = { value: 0 };
monthGroup.days.push(day);
}
yearGroup.value += value;
monthGroup.value += value;
dayGroup.value += value;
yearGroup.indexes.push(dateIndex);
monthGroup.indexes.push(dateIndex);
}
}
getOneRecordValue(columnName, exclusiveIndex) {
let columnIndexes = this.getRowIndexes(columnName, exclusiveIndex);
let sheet = this.sheet, table = this.getTable(), dataRangeInSheet = table.dataRange(), startRow = dataRangeInSheet.row, startCol = dataRangeInSheet.col, result = 0;
for (let r = 0; r < columnIndexes.length; r++) {
for (let c = this.dataStartIndex; c <= this.dataEndIndex; c++) {
let value = sheet.getValue(columnIndexes[r] + startRow, c + startCol);
result += value;
}
}
return result;
}
getDatasByYear() {
let dateGroup = this.dateGroup;
let years = dateGroup.years;
let result = [];
for (let i = 0; i < years.length; i++) {
let year = years[i];
result.push({ title: year, value: dateGroup[year].value });
}
return result;
}
getMonthDatasByYear(year) {
let dateGroup = this.dateGroup;
let yearGroup = dateGroup[year], monthes = yearGroup.monthes;
let result = [];
for (let i = 0; i < monthes.length; i++) {
let month = monthes[i];
result.push({ title: month, value: yearGroup[month].value });
}
return result;
}
getDayDatasByMonth(year, month) {
let dateGroup = this.dateGroup;
let yearGroup = dateGroup[year], monthGroup = yearGroup[month], days = monthGroup.days;
let result = [];
for (let i = 0; i < days.length; i++) {
let day = days[i];
result.push({ title: day, value: monthGroup[day].value });
}
return result;
}
filterOnYear(columnName, year) {
let yearGroup = this.dateGroup[year];
let indexes = yearGroup.indexes;
this.mode = AggregationSlicerData_YEAR;
this.doFilter(columnName, { exclusiveRowIndexes: indexes });
this.mode = AggregationSlicerData_OTHER;
}
filterOnMonth(columnName, year, month) {
let yearGroup = this.dateGroup[year];
let monthGroup = yearGroup[month];
let indexes = monthGroup.indexes;
this.mode = AggregationSlicerData_MONTH;
this.doFilter(columnName, { exclusiveRowIndexes: indexes });
this.mode = AggregationSlicerData_OTHER;
}
onFiltered(filteredIndexes, isPreview) {
for (let i = 0; i < this.listeners.length; i++) {
this.listeners[i].onFiltered({ columnIndexes: filteredIndexes, isPreview: isPreview, mode: this.mode });
}
}
attachListener(listener) {
this.listeners.push(listener);
}
dettachListener(listener) {
for (let i = 0; i < this.listeners.length; i++) {
if (this.listeners[i] === listener) {
this.listeners.splice(i);
break;
}
}
}
clearFilter(columnName) {
this.doUnfilter(columnName);
}
}
let Bar = (function () {
function Bar(title, value, x, width, disable) {
if (disable === void 0) { disable = false; }
this.disable = false;
this.title = title;
this.value = value;
this.disable = disable;
this.x = x;
this.width = width;
}
return Bar;
})();
class TimelineSlicer {
constructor(slicerData, columnName) {
this.root = null;
this.header = null;
this._canExpand = true;
this.mode = AggregationSlicerData_YEAR;
slicerData.buildDateGroups(columnName);
this.aggregationData = slicerData;
this.slicerData = slicerData;
this.columnName = columnName;
this.data = slicerData.getData(columnName);
this.exclusiveDatas = slicerData.getExclusiveData(columnName);
this.slicerData.attachListener(this);
this.onDataLoaded();
}
getDOMElement() {
return this.root;
}
getHeader() {
return this.header;
}
onDataLoaded() {
let self = this;
self.initHeader();
let div = document.createElement('div');
div.style.width = '100%';
div.style.height = '100%';
div.innerHTML = '<canvas width=250 height=200></canvas>'
let canvas = div.firstChild;
this.canvas = canvas;
this.root = div;
canvas.onmousemove = function (event) {
let bar = self.hitTest(event.offsetX, event.offsetY);
if (bar !== self.hoverBar) {
self.hoverBar = bar;
self.paint();
}
};
canvas.onmouseout = function () {
self.hoverBar = null;
self.paint();
};
canvas.onclick = function (event) {
let bar = self.hitTest(event.offsetX, event.offsetY);
if (!bar) {
return;
}
if (bar !== self.selectedBar) {
if (!self.canExpand()) {
self.selectedBar = bar;
if (self.mode === AggregationSlicerData_YEAR) {
self.selectedYear = parseInt(bar.title, 10);
self.aggregationData.filterOnYear(self.columnName, self.selectedYear);
}
else if (self.mode === AggregationSlicerData_MONTH) {
self.selectedMonth = parseInt(bar.title, 10);
self.aggregationData.filterOnMonth(self.columnName, self.selectedYear, self.selectedMonth);
}
}
else {
if (self.mode === AggregationSlicerData_YEAR) {
self.selectedBar = null;
self.selectedYear = parseInt(bar.title, 10);
self.mode = AggregationSlicerData_MONTH;
self.bars = self.getBars();
self.aggregationData.filterOnYear(self.columnName, self.selectedYear);
}
}
self.paint();
}
};
this.bars = this.getBars();
self.paint();
}
initHeader() {
let headerContainer = document.createElement('div');
headerContainer.innerHTML = '<p class="desc">Check this to allow the user to expand the year into months.</p>'
+ '<input id="canExpand" type="checkbox"/>'
+ '<label for="canExpand">Allow Year to Month Aggregation</label>'
+ '<input id="return" type="button" value="Change back to year aggregation">';
this.header = headerContainer;
}
attachEventsToHeader() {
let canExpand = _getElementById("canExpand");
canExpand.checked = this._canExpand;
canExpand.onchange = function (sender, args) {
self._canExpand = canExpand.checked;
};
let returnButton = _getElementById("return");
returnButton.style.width = "100%";
let self = this;
returnButton.onclick = function () {
if (self.mode === AggregationSlicerData_YEAR) {
return;
}
self.mode = AggregationSlicerData_YEAR;
self.selectedBar = null;
self.bars = self.getBars();
self.paint();
self.aggregationData.doUnfilter(self.columnName);
}
}
hitTest(x, y) {
let bars = this.bars;
for (let i = 0; i < bars.length; i++) {
let bar = bars[i];
if (x >= bar.x && x < bar.x + bar.width) {
return bar;
}
}
return null;
}
paint() {
let context = this.canvas.getContext("2d");
let bars = this.bars;
let topValue = this.getTopValue(bars);
let width = this.canvas.width;
let height = this.canvas.height;
let ruleHeight = 20, borderWidth = 2;
let maxBarHeight = height - ruleHeight;
context.clearRect(0, 0, width, height);
for (let i = 0; i < bars.length; i++) {
let bar = bars[i];
if (bar === this.selectedBar) {
context.fillStyle = "#1b1b1b";
context.fillRect(bar.x - borderWidth * 2, 0, bar.width + 4 * borderWidth, height);
context.fillStyle = "#E1E1E1";
context.fillRect(bar.x - borderWidth, 0 + borderWidth, bar.width + 2 * borderWidth, height - 2 * borderWidth);
}
else if (bar === this.hoverBar) {
context.fillStyle = "#C1C1C1";
context.fillRect(bar.x - borderWidth, 0 + borderWidth, bar.width + 2 * borderWidth, height - 2 * borderWidth);
}
if (this.selectedBar && bar !== this.selectedBar) {
context.fillStyle = "#003c4d";
}
else {
context.fillStyle = "#0096c0";
}
context.fillText(this.getTitle(bar.title), bar.x + borderWidth * 2, height - borderWidth * 4);
let barHeight = maxBarHeight * bar.value / topValue;
context.fillRect(bar.x, maxBarHeight - barHeight, bar.width, barHeight);
}
}
getTitle(title) {
let monthes = ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"];
if (this.mode === AggregationSlicerData_MONTH) {
return monthes[parseInt(title, 10)];
}
return title;
}
getTopValue(bars) {
let max = bars[0].value;
for (let i = 1; i < bars.length; i++) {
max = max < bars[i].value ? bars[i].value : max;
}
let base = 1;
while (max / base >= 10) {
base *= 10;
}
let head = max / base;
return Math.ceil(head) * base;
}
currentSelection() {
if (this.canExpand()) {
return -1;
}
switch (this.mode) {
case AggregationSlicerData_YEAR:
return this.selectedYear;
case AggregationSlicerData_MONTH:
return this.selectedMonth;
}
return -1;
}
getBars() {
let result = [];
let datas;
if (this.mode === AggregationSlicerData_YEAR) {
datas = this.aggregationData.getDatasByYear();
}
else if (this.mode === AggregationSlicerData_MONTH) {
datas = this.aggregationData.getMonthDatasByYear(this.selectedYear);
}
else {
datas = this.aggregationData.getDayDatasByMonth(this.selectedYear, this.selectedMonth);
}
let length = datas.length;
let barLayout = this.getBarLayout(length);
let current = this.currentSelection();
for (let i = 0; i < length; i++) {
result.push(new Bar(datas[i].title + "", datas[i].value, this.getX(barLayout, length, i), barLayout.width, false));
}
return result;
}
getX(layout, count, index) {
if (count <= 12) {
return layout.margin * (index + 1) + layout.width * index;
}
else {
let current = this.currentSelection();
if (current < 5) {
return layout.margin * (index + 1) + layout.width * index;
}
else {
let displayIndex = index - 5;
if (displayIndex < 0) {
return -100;
}
return layout.margin * (displayIndex + 1) + layout.width * displayIndex - layout.width / 2;
}
}
}
canExpand() {
return this._canExpand && this.mode !== AggregationSlicerData_MONTH;
}
getBarLayout(count) {
let fullWidth = this.canvas.width, margin, width;
let fold = 5;
if (count <= 12) {
margin = fullWidth / ((fold + 1) * count + 1);
width = fold * margin;
}
else {
margin = fullWidth / ((fold + 1) * 10 + 1);
width = fold * margin;
}
return { margin: margin, width: width };
}
onFiltered(data) {
};
}
export function AppFunc() {
const initSpread = (spread) => {
let sd = data;
if (sd && sd[0].sheets) {
if (!spread) {
return;
}
spread.suspendPaint();
spread.fromJSON(sd[0]);
spread.resumePaint();
addAggregationSlicer(spread);
}
}
return (
<div class="sample-tutorial">
<div class="sample-spreadsheets">
<SpreadSheets workbookInitialized={spread => initSpread(spread)}>
</SpreadSheets>
</div>
<div class="options-container">
<div id="slicer_Timeline"></div>
</div>
</div>
);
}
import * as React from 'react';
import GC from '@mescius/spread-sheets';
import { SpreadSheets } from '@mescius/spread-sheets-react';
import "@mescius/spread-sheets-slicers";
const Component = React.Component;
function _getElementById(id) {
return document.getElementById(id);
}
function addAggregationSlicer(spread) {
let sheet = spread.getActiveSheet();
let table = sheet.tables.find(0, 0);
let dataSource = new AggregationSlicerData(sheet, table, 1, 5);
let timeSlicer = new TimelineSlicer(dataSource, "Date");
let slicerTimeLine = _getElementById('slicer_Timeline');
slicerTimeLine.innerHTML = '<p style="padding:2px 10px; background-color:#F4F8EB">Click on the items in the chart slicer to filter by</p>';
slicerTimeLine.appendChild(timeSlicer.getDOMElement());
slicerTimeLine.appendChild(timeSlicer.getHeader());
timeSlicer.attachEventsToHeader();
}
const AggregationSlicerData_YEAR = 0, AggregationSlicerData_MONTH = 1, AggregationSlicerData_OTHER = 2;
class AggregationSlicerData extends GC.Spread.Sheets.Slicers.TableSlicerData {
constructor (sheet, table, dataStartIndex, dataEndIndex) {
super(table);
this.dateGroup = {years: []};
this.listeners = [];
this.dataStartIndex = dataStartIndex;
this.dataEndIndex = dataEndIndex;
this.sheet = sheet;
}
buildDateGroups (columnName) {
let allDates = this.getExclusiveData(columnName);
let dateGroup = this.dateGroup;
for (let dateIndex = 0; dateIndex < allDates.length; dateIndex++) {
let value = this.getOneRecordValue(columnName, dateIndex);
let date = new Date(allDates[dateIndex]);
let year = date.getFullYear(), month = date.getMonth(), day = date.getDate();
let yearGroup = dateGroup[year];
if (!yearGroup) {
yearGroup = dateGroup[year] = {value: 0, monthes: [], indexes: []};
dateGroup.years.push(year);
}
let monthGroup = yearGroup[month];
if (!monthGroup) {
monthGroup = yearGroup[month] = {value: 0, days: [], indexes: []};
yearGroup.monthes.push(month);
}
let dayGroup = monthGroup[day];
if (!dayGroup) {
dayGroup = monthGroup[day] = {value: 0};
monthGroup.days.push(day);
}
yearGroup.value += value;
monthGroup.value += value;
dayGroup.value += value;
yearGroup.indexes.push(dateIndex);
monthGroup.indexes.push(dateIndex);
}
}
getOneRecordValue (columnName, exclusiveIndex) {
let columnIndexes = this.getRowIndexes(columnName, exclusiveIndex);
let sheet = this.sheet, table = this.getTable(), dataRangeInSheet = table.dataRange(), startRow = dataRangeInSheet.row, startCol = dataRangeInSheet.col, result = 0;
for (let r = 0; r < columnIndexes.length; r++) {
for (let c = this.dataStartIndex; c <= this.dataEndIndex; c++) {
let value = sheet.getValue(columnIndexes[r] + startRow, c + startCol);
result += value;
}
}
return result;
}
getDatasByYear () {
let dateGroup = this.dateGroup;
let years = dateGroup.years;
let result = [];
for (let i = 0; i < years.length; i++) {
let year = years[i];
result.push({title: year, value: dateGroup[year].value});
}
return result;
}
getMonthDatasByYear (year) {
let dateGroup = this.dateGroup;
let yearGroup = dateGroup[year], monthes = yearGroup.monthes;
let result = [];
for (let i = 0; i < monthes.length; i++) {
let month = monthes[i];
result.push({title: month, value: yearGroup[month].value});
}
return result;
}
getDayDatasByMonth (year, month) {
let dateGroup = this.dateGroup;
let yearGroup = dateGroup[year], monthGroup = yearGroup[month], days = monthGroup.days;
let result = [];
for (let i = 0; i < days.length; i++) {
let day = days[i];
result.push({title: day, value: monthGroup[day].value});
}
return result;
}
filterOnYear (columnName, year) {
let yearGroup = this.dateGroup[year];
let indexes = yearGroup.indexes;
this.mode = AggregationSlicerData_YEAR;
this.doFilter(columnName, {exclusiveRowIndexes: indexes});
this.mode = AggregationSlicerData_OTHER;
}
filterOnMonth (columnName, year, month) {
let yearGroup = this.dateGroup[year];
let monthGroup = yearGroup[month];
let indexes = monthGroup.indexes;
this.mode = AggregationSlicerData_MONTH;
this.doFilter(columnName, {exclusiveRowIndexes: indexes});
this.mode = AggregationSlicerData_OTHER;
}
onFiltered (filteredIndexes, isPreview) {
for (let i = 0; i < this.listeners.length; i++) {
this.listeners[i].onFiltered({columnIndexes: filteredIndexes, isPreview: isPreview, mode: this.mode});
}
}
attachListener (listener) {
this.listeners.push(listener);
}
dettachListener (listener) {
for (let i = 0; i < this.listeners.length; i++) {
if (this.listeners[i] === listener) {
this.listeners.splice(i);
break;
}
}
}
clearFilter (columnName) {
this.doUnfilter(columnName);
}
}
let Bar = (function () {
function Bar(title, value, x, width, disable) {
if (disable === void 0) {disable = false;}
this.disable = false;
this.title = title;
this.value = value;
this.disable = disable;
this.x = x;
this.width = width;
}
return Bar;
})();
class TimelineSlicer {
constructor (slicerData, columnName) {
this.root = null;
this.header = null;
this._canExpand = true;
this.mode = AggregationSlicerData_YEAR;
slicerData.buildDateGroups(columnName);
this.aggregationData = slicerData;
this.slicerData = slicerData;
this.columnName = columnName;
this.data = slicerData.getData(columnName);
this.exclusiveDatas = slicerData.getExclusiveData(columnName);
this.slicerData.attachListener(this);
this.onDataLoaded();
}
getDOMElement () {
return this.root;
}
getHeader () {
return this.header;
}
onDataLoaded () {
let self = this;
self.initHeader();
let div = document.createElement('div');
div.style.width = '100%';
div.style.height = '100%';
div.innerHTML = '<canvas width=250 height=200></canvas>'
let canvas = div.firstChild;
this.canvas = canvas;
this.root = div;
canvas.onmousemove = function (event) {
let bar = self.hitTest(event.offsetX, event.offsetY);
if (bar !== self.hoverBar) {
self.hoverBar = bar;
self.paint();
}
};
canvas.onmouseout = function () {
self.hoverBar = null;
self.paint();
};
canvas.onclick = function (event) {
let bar = self.hitTest(event.offsetX, event.offsetY);
if (!bar) {
return;
}
if (bar !== self.selectedBar) {
if (!self.canExpand()) {
self.selectedBar = bar;
if (self.mode === AggregationSlicerData_YEAR) {
self.selectedYear = parseInt(bar.title, 10);
self.aggregationData.filterOnYear(self.columnName, self.selectedYear);
}
else if (self.mode === AggregationSlicerData_MONTH) {
self.selectedMonth = parseInt(bar.title, 10);
self.aggregationData.filterOnMonth(self.columnName, self.selectedYear, self.selectedMonth);
}
}
else {
if (self.mode === AggregationSlicerData_YEAR) {
self.selectedBar = null;
self.selectedYear = parseInt(bar.title, 10);
self.mode = AggregationSlicerData_MONTH;
self.bars = self.getBars();
self.aggregationData.filterOnYear(self.columnName, self.selectedYear);
}
}
self.paint();
}
};
this.bars = this.getBars();
self.paint();
}
initHeader () {
let headerContainer = document.createElement('div');
headerContainer.innerHTML = '<p class="desc">Check this to allow the user to expand the year into months.</p>'
+ '<input id="canExpand" type="checkbox"/>'
+ '<label for="canExpand">Allow Year to Month Aggregation</label>'
+ '<input id="return" type="button" value="Change back to year aggregation">';
this.header = headerContainer;
}
attachEventsToHeader () {
let canExpand = _getElementById("canExpand");
canExpand.checked=this._canExpand;
canExpand.onchange = function (sender, args) {
self._canExpand = canExpand.checked;
};
let returnButton = _getElementById("return");
returnButton.style.width = "100%";
let self = this;
returnButton.onclick=function () {
if (self.mode === AggregationSlicerData_YEAR) {
return;
}
self.mode = AggregationSlicerData_YEAR;
self.selectedBar = null;
self.bars = self.getBars();
self.paint();
self.aggregationData.doUnfilter(self.columnName);
}
}
hitTest (x, y) {
let bars = this.bars;
for (let i = 0; i < bars.length; i++) {
let bar = bars[i];
if (x >= bar.x && x < bar.x + bar.width) {
return bar;
}
}
return null;
}
paint () {
let context = this.canvas.getContext("2d");
let bars = this.bars;
let topValue = this.getTopValue(bars);
let width = this.canvas.width;
let height = this.canvas.height;
let ruleHeight = 20, borderWidth = 2;
let maxBarHeight = height - ruleHeight;
context.clearRect(0, 0, width, height);
for (let i = 0; i < bars.length; i++) {
let bar = bars[i];
if (bar === this.selectedBar) {
context.fillStyle = "#1b1b1b";
context.fillRect(bar.x - borderWidth * 2, 0, bar.width + 4 * borderWidth, height);
context.fillStyle = "#E1E1E1";
context.fillRect(bar.x - borderWidth, 0 + borderWidth, bar.width + 2 * borderWidth, height - 2 * borderWidth);
}
else if (bar === this.hoverBar) {
context.fillStyle = "#C1C1C1";
context.fillRect(bar.x - borderWidth, 0 + borderWidth, bar.width + 2 * borderWidth, height - 2 * borderWidth);
}
if (this.selectedBar && bar !== this.selectedBar) {
context.fillStyle = "#003c4d";
}
else {
context.fillStyle = "#0096c0";
}
context.fillText(this.getTitle(bar.title), bar.x + borderWidth * 2, height - borderWidth * 4);
let barHeight = maxBarHeight * bar.value / topValue;
context.fillRect(bar.x, maxBarHeight - barHeight, bar.width, barHeight);
}
}
getTitle (title) {
let monthes = ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"];
if (this.mode === AggregationSlicerData_MONTH) {
return monthes[parseInt(title, 10)];
}
return title;
}
getTopValue (bars) {
let max = bars[0].value;
for (let i = 1; i < bars.length; i++) {
max = max < bars[i].value ? bars[i].value : max;
}
let base = 1;
while (max / base >= 10) {
base *= 10;
}
let head = max / base;
return Math.ceil(head) * base;
}
currentSelection () {
if (this.canExpand()) {
return -1;
}
switch (this.mode) {
case AggregationSlicerData_YEAR:
return this.selectedYear;
case AggregationSlicerData_MONTH:
return this.selectedMonth;
}
return -1;
}
getBars () {
let result = [];
let datas;
if (this.mode === AggregationSlicerData_YEAR) {
datas = this.aggregationData.getDatasByYear();
}
else if (this.mode === AggregationSlicerData_MONTH) {
datas = this.aggregationData.getMonthDatasByYear(this.selectedYear);
}
else {
datas = this.aggregationData.getDayDatasByMonth(this.selectedYear, this.selectedMonth);
}
let length = datas.length;
let barLayout = this.getBarLayout(length);
let current = this.currentSelection();
for (let i = 0; i < length; i++) {
result.push(new Bar(datas[i].title + "", datas[i].value, this.getX(barLayout, length, i), barLayout.width, false));
}
return result;
}
getX (layout, count, index) {
if (count <= 12) {
return layout.margin * (index + 1) + layout.width * index;
}
else {
let current = this.currentSelection();
if (current < 5) {
return layout.margin * (index + 1) + layout.width * index;
}
else {
let displayIndex = index - 5;
if (displayIndex < 0) {
return -100;
}
return layout.margin * (displayIndex + 1) + layout.width * displayIndex - layout.width / 2;
}
}
}
canExpand () {
return this._canExpand && this.mode !== AggregationSlicerData_MONTH;
}
getBarLayout (count) {
let fullWidth = this.canvas.width, margin, width;
let fold = 5;
if (count <= 12) {
margin = fullWidth / ((fold + 1) * count + 1);
width = fold * margin;
}
else {
margin = fullWidth / ((fold + 1) * 10 + 1);
width = fold * margin;
}
return {margin: margin, width: width};
}
onFiltered (data) {
};
}
export class App extends Component {
constructor(props) {
super(props);
}
render() {
return (
<div class="sample-tutorial">
<div class="sample-spreadsheets">
<SpreadSheets workbookInitialized={spread=>this.initSpread(spread)}>
</SpreadSheets>
</div>
<div class="options-container">
<div id="slicer_Timeline"></div>
</div>
</div>
);
}
initSpread(spread) {
let sd = data;
if (sd && sd[0].sheets) {
if (!spread) {
return;
}
spread.suspendPaint();
spread.fromJSON(sd[0]);
spread.resumePaint();
addAggregationSlicer(spread);
}
}
}
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/react/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<script src="$DEMOROOT$/spread/source/data/aggregationSlicer.js" type="text/javascript"></script>
<!-- SystemJS -->
<script src="$DEMOROOT$/en/react/node_modules/systemjs/dist/system.src.js"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('$DEMOROOT$/en/lib/react/license.js').then(function () {
System.import('./src/app');
});
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 280px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.option-row {
font-size: 14px;
padding: 5px;
margin-top: 10px;
}
input[type=button] {
padding: 4px 6px;
box-sizing: border-box;
margin: 6px 0;
display: block;
}
#slicer_Timeline{
padding-bottom: 20px;
}
.desc {
padding:2px 10px;
background-color:#F4F8EB;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
#app {
height: 100%;
}
(function (global) {
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true,
react: true
},
meta: {
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/',
'cdn:': 'https://cdn.mescius.io/demoapps/packages/spreadjs/19.1.2-master-2026-06-10-2131/'
},
// map tells the System loader where to look for things
map: {
'@mescius/spread-sheets': 'cdn:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-shapes': 'cdn:@mescius/spread-sheets-shapes/index.js',
'@mescius/spread-sheets-slicers': 'cdn:@mescius/spread-sheets-slicers/index.js',
'@mescius/spread-sheets-react': 'cdn:@mescius/spread-sheets-react/index.js',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js',
'react': 'npm:react/cjs/react.production.js',
'react-dom': 'npm:react-dom/cjs/react-dom.production.js',
'react-dom/client': 'npm:react-dom/cjs/react-dom-client.production.js',
'scheduler': 'npm:scheduler/cjs/scheduler.production.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'jsx'
},
"node_modules": {
defaultExtension: 'js'
},
}
});
})(this);

aggregateData(columnName: string, aggregateType: SlicerAggregateType, range?: ISlicerRangeConditional): number
SlicerAggregateType provides 11 aggregate function types as follows:
AVERAGE
COUNT
COUNTA
MAX
MIN
PRODUCT
STDEV
STDEVP
SUBTOTAL
SUM
VARS
VARP
You can also create your own data aggregation slicer as shown in the following code.
<template>
<div class="sample-tutorial">
<gc-spread-sheets class="sample-spreadsheets" @workbookInitialized="initSpread">
</gc-spread-sheets>
<div class="options-container">
<div id="slicer_Timeline"></div>
</div>
</div>
</template>
<script setup>
import '@mescius/spread-sheets-vue'
import { ref } from "vue";
import GC from "@mescius/spread-sheets";
import "@mescius/spread-sheets-slicers";
const spreadRef = ref(null);
let initSpread = function (spread) {
spreadRef.value = spread;
let sheet = spreadRef.value.getSheet(0);
sheet.suspendPaint();
let sd = data;
if (sd && sd[0].sheets) {
if (!spread) {
return;
}
spread.suspendPaint();
spread.fromJSON(sd[0]);
spread.resumePaint();
addAggregationSlicer(spread);
}
}
function addAggregationSlicer(spread) {
let sheet = spread.getActiveSheet();
let table = sheet.tables.find(0, 0);
let dataSource = new AggregationSlicerData(sheet, table, 1, 5);
let timeSlicer = new TimelineSlicer(dataSource, "Date");
let slicerTimeLine = document.getElementById('slicer_Timeline');
slicerTimeLine.innerHTML = '<p style="padding:2px 10px; background-color:#F4F8EB">Click on the items in the chart slicer to filter by</p>';
slicerTimeLine.appendChild(timeSlicer.getDOMElement());
slicerTimeLine.appendChild(timeSlicer.getHeader());
timeSlicer.attachEventsToHeader();
}
const AggregationSlicerData_YEAR = 0, AggregationSlicerData_MONTH = 1, AggregationSlicerData_OTHER = 2;
class AggregationSlicerData extends GC.Spread.Sheets.Slicers.TableSlicerData {
constructor(sheet, table, dataStartIndex, dataEndIndex) {
super(table);
this.dateGroup = { years: [] };
this.listeners = [];
this.dataStartIndex = dataStartIndex;
this.dataEndIndex = dataEndIndex;
this.sheet = sheet;
}
buildDateGroups(columnName) {
let allDates = this.getExclusiveData(columnName);
let dateGroup = this.dateGroup;
for (let dateIndex = 0; dateIndex < allDates.length; dateIndex++) {
let value = this.getOneRecordValue(columnName, dateIndex);
let date = new Date(allDates[dateIndex]);
let year = date.getFullYear(), month = date.getMonth(), day = date.getDate();
let yearGroup = dateGroup[year];
if (!yearGroup) {
yearGroup = dateGroup[year] = { value: 0, monthes: [], indexes: [] };
dateGroup.years.push(year);
}
let monthGroup = yearGroup[month];
if (!monthGroup) {
monthGroup = yearGroup[month] = { value: 0, days: [], indexes: [] };
yearGroup.monthes.push(month);
}
let dayGroup = monthGroup[day];
if (!dayGroup) {
dayGroup = monthGroup[day] = { value: 0 };
monthGroup.days.push(day);
}
yearGroup.value += value;
monthGroup.value += value;
dayGroup.value += value;
yearGroup.indexes.push(dateIndex);
monthGroup.indexes.push(dateIndex);
}
}
getOneRecordValue(columnName, exclusiveIndex) {
let columnIndexes = this.getRowIndexes(columnName, exclusiveIndex);
let sheet = this.sheet, table = this.getTable(), dataRangeInSheet = table.dataRange(), startRow = dataRangeInSheet.row, startCol = dataRangeInSheet.col, result = 0;
for (let r = 0; r < columnIndexes.length; r++) {
for (let c = this.dataStartIndex; c <= this.dataEndIndex; c++) {
let value = sheet.getValue(columnIndexes[r] + startRow, c + startCol);
result += value;
}
}
return result;
}
getDatasByYear() {
let dateGroup = this.dateGroup;
let years = dateGroup.years;
let result = [];
for (let i = 0; i < years.length; i++) {
let year = years[i];
result.push({ title: year, value: dateGroup[year].value });
}
return result;
}
getMonthDatasByYear(year) {
let dateGroup = this.dateGroup;
let yearGroup = dateGroup[year], monthes = yearGroup.monthes;
let result = [];
for (let i = 0; i < monthes.length; i++) {
let month = monthes[i];
result.push({ title: month, value: yearGroup[month].value });
}
return result;
}
getDayDatasByMonth(year, month) {
let dateGroup = this.dateGroup;
let yearGroup = dateGroup[year], monthGroup = yearGroup[month], days = monthGroup.days;
let result = [];
for (let i = 0; i < days.length; i++) {
let day = days[i];
result.push({ title: day, value: monthGroup[day].value });
}
return result;
}
filterOnYear(columnName, year) {
let yearGroup = this.dateGroup[year];
let indexes = yearGroup.indexes;
this.mode = AggregationSlicerData_YEAR;
this.doFilter(columnName, { exclusiveRowIndexes: indexes });
this.mode = AggregationSlicerData_OTHER;
}
filterOnMonth(columnName, year, month) {
let yearGroup = this.dateGroup[year];
let monthGroup = yearGroup[month];
let indexes = monthGroup.indexes;
this.mode = AggregationSlicerData_MONTH;
this.doFilter(columnName, { exclusiveRowIndexes: indexes });
this.mode = AggregationSlicerData_OTHER;
}
onFiltered(filteredIndexes, isPreview) {
for (let i = 0; i < this.listeners.length; i++) {
this.listeners[i].onFiltered({ columnIndexes: filteredIndexes, isPreview: isPreview, mode: this.mode });
}
}
attachListener(listener) {
this.listeners.push(listener);
}
detachListener(listener) {
for (let i = 0; i < this.listeners.length; i++) {
if (this.listeners[i] === listener) {
this.listeners.splice(i);
break;
}
}
}
clearFilter(columnName) {
this.doUnfilter(columnName);
}
}
let Bar = (function () {
function Bar(title, value, x, width, disable) {
if (disable === void 0) { disable = false; }
this.disable = false;
this.title = title;
this.value = value;
this.disable = disable;
this.x = x;
this.width = width;
}
return Bar;
})();
class TimelineSlicer {
constructor(slicerData, columnName) {
this.root = null;
this.header = null;
this._canExpand = true;
this.mode = AggregationSlicerData_YEAR;
slicerData.buildDateGroups(columnName);
this.aggregationData = slicerData;
this.slicerData = slicerData;
this.columnName = columnName;
this.data = slicerData.getData(columnName);
this.exclusiveDatas = slicerData.getExclusiveData(columnName);
this.slicerData.attachListener(this);
this.onDataLoaded();
}
getDOMElement() {
return this.root;
}
getHeader() {
return this.header;
}
onDataLoaded() {
let self = this;
self.initHeader();
let div = document.createElement('div');
div.style.width = '100%';
div.style.height = '100%';
div.innerHTML = '<canvas width=250 height=200></canvas>'
let canvas = div.firstChild;
this.canvas = canvas;
this.root = div;
canvas.onmousemove = function (event) {
let bar = self.hitTest(event.offsetX, event.offsetY);
if (bar !== self.hoverBar) {
self.hoverBar = bar;
self.paint();
}
};
canvas.onmouseout = function () {
self.hoverBar = null;
self.paint();
};
canvas.onclick = function (event) {
let bar = self.hitTest(event.offsetX, event.offsetY);
if (!bar) {
return;
}
if (bar !== self.selectedBar) {
if (!self.canExpand()) {
self.selectedBar = bar;
if (self.mode === AggregationSlicerData_YEAR) {
self.selectedYear = parseInt(bar.title, 10);
self.aggregationData.filterOnYear(self.columnName, self.selectedYear);
}
else if (self.mode === AggregationSlicerData_MONTH) {
self.selectedMonth = parseInt(bar.title, 10);
self.aggregationData.filterOnMonth(self.columnName, self.selectedYear, self.selectedMonth);
}
}
else {
if (self.mode === AggregationSlicerData_YEAR) {
self.selectedBar = null;
self.selectedYear = parseInt(bar.title, 10);
self.mode = AggregationSlicerData_MONTH;
self.bars = self.getBars();
self.aggregationData.filterOnYear(self.columnName, self.selectedYear);
}
}
self.paint();
}
};
this.bars = this.getBars();
self.paint();
}
initHeader() {
let headerContainer = document.createElement('div');
headerContainer.innerHTML = '<p class="desc">Check this to allow the user to expand the year into months.</p>'
+ '<input id="canExpand" type="checkbox"/>'
+ '<label for="canExpand">Allow Year to Month Aggregation</label>'
+ '<input id="return" type="button" value="Change back to year aggregation">';
this.header = headerContainer;
}
attachEventsToHeader() {
let canExpand = document.getElementById("canExpand");
canExpand.checked = this._canExpand;
canExpand.onchange = function (sender, args) {
self._canExpand = canExpand.checked;
};
let returnButton = document.getElementById("return");
returnButton.style.width = "100%";
let self = this;
returnButton.onclick = function () {
if (self.mode === AggregationSlicerData_YEAR) {
return;
}
self.mode = AggregationSlicerData_YEAR;
self.selectedBar = null;
self.bars = self.getBars();
self.paint();
self.aggregationData.doUnfilter(self.columnName);
}
}
hitTest(x, y) {
let bars = this.bars;
for (let i = 0; i < bars.length; i++) {
let bar = bars[i];
if (x >= bar.x && x < bar.x + bar.width) {
return bar;
}
}
return null;
}
paint() {
let context = this.canvas.getContext("2d");
let bars = this.bars;
let topValue = this.getTopValue(bars);
let width = this.canvas.width;
let height = this.canvas.height;
let ruleHeight = 20, borderWidth = 2;
let maxBarHeight = height - ruleHeight;
context.clearRect(0, 0, width, height);
for (let i = 0; i < bars.length; i++) {
let bar = bars[i];
if (bar === this.selectedBar) {
context.fillStyle = "#1b1b1b";
context.fillRect(bar.x - borderWidth * 2, 0, bar.width + 4 * borderWidth, height);
context.fillStyle = "#E1E1E1";
context.fillRect(bar.x - borderWidth, 0 + borderWidth, bar.width + 2 * borderWidth, height - 2 * borderWidth);
}
else if (bar === this.hoverBar) {
context.fillStyle = "#C1C1C1";
context.fillRect(bar.x - borderWidth, 0 + borderWidth, bar.width + 2 * borderWidth, height - 2 * borderWidth);
}
if (this.selectedBar && bar !== this.selectedBar) {
context.fillStyle = "#003c4d";
}
else {
context.fillStyle = "#0096c0";
}
context.fillText(this.getTitle(bar.title), bar.x + borderWidth * 2, height - borderWidth * 4);
let barHeight = maxBarHeight * bar.value / topValue;
context.fillRect(bar.x, maxBarHeight - barHeight, bar.width, barHeight);
}
}
getTitle(title) {
let monthes = ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"];
if (this.mode === AggregationSlicerData_MONTH) {
return monthes[parseInt(title, 10)];
}
return title;
}
getTopValue(bars) {
let max = bars[0].value;
for (let i = 1; i < bars.length; i++) {
max = max < bars[i].value ? bars[i].value : max;
}
let base = 1;
while (max / base >= 10) {
base *= 10;
}
let head = max / base;
return Math.ceil(head) * base;
}
currentSelection() {
if (this.canExpand()) {
return -1;
}
switch (this.mode) {
case AggregationSlicerData_YEAR:
return this.selectedYear;
case AggregationSlicerData_MONTH:
return this.selectedMonth;
}
return -1;
}
getBars() {
let result = [];
let datas;
if (this.mode === AggregationSlicerData_YEAR) {
datas = this.aggregationData.getDatasByYear();
}
else if (this.mode === AggregationSlicerData_MONTH) {
datas = this.aggregationData.getMonthDatasByYear(this.selectedYear);
}
else {
datas = this.aggregationData.getDayDatasByMonth(this.selectedYear, this.selectedMonth);
}
let length = datas.length;
let barLayout = this.getBarLayout(length);
let current = this.currentSelection();
for (let i = 0; i < length; i++) {
result.push(new Bar(datas[i].title + "", datas[i].value, this.getX(barLayout, length, i), barLayout.width, false));
}
return result;
}
getX(layout, count, index) {
if (count <= 12) {
return layout.margin * (index + 1) + layout.width * index;
}
else {
let current = this.currentSelection();
if (current < 5) {
return layout.margin * (index + 1) + layout.width * index;
}
else {
let displayIndex = index - 5;
if (displayIndex < 0) {
return -100;
}
return layout.margin * (displayIndex + 1) + layout.width * displayIndex - layout.width / 2;
}
}
}
canExpand() {
return this._canExpand && this.mode !== AggregationSlicerData_MONTH;
}
getBarLayout(count) {
let fullWidth = this.canvas.width, margin, width;
let fold = 5;
if (count <= 12) {
margin = fullWidth / ((fold + 1) * count + 1);
width = fold * margin;
}
else {
margin = fullWidth / ((fold + 1) * 10 + 1);
width = fold * margin;
}
return { margin: margin, width: width };
}
onFiltered(data) {
};
}
</script>
<style scoped>
#app {
height: 100%;
}
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 280px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.option-row {
font-size: 14px;
padding: 5px;
margin-top: 10px;
}
input[type=button] {
padding: 4px 6px;
box-sizing: border-box;
margin: 6px 0;
display: block;
}
#slicer_Timeline{
padding-bottom: 20px;
}
.desc {
padding:2px 10px;
background-color:#F4F8EB;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
</style>
<!DOCTYPE html>
<html lang="en" style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<title>SpreadJS VUE</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css"
href="$DEMOROOT$/en/vue3/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<script src="$DEMOROOT$/spread/source/data/aggregationSlicer.js" type="text/javascript"></script>
<script src="$DEMOROOT$/en/vue3/node_modules/systemjs/dist/system.src.js"></script>
<script src="./systemjs.config.js"></script>
<script src="./compiler.js" type="module"></script>
<script>
var System = SystemJS;
System.import("./src/app.js");
System.import('$DEMOROOT$/en/lib/vue3/license.js');
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
(function (global) {
SystemJS.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true
},
paths: {
// paths serve as alias
'npm:': 'node_modules/',
'cdn:': 'https://cdn.mescius.io/demoapps/packages/spreadjs/19.1.2-master-2026-06-10-2131/'
},
packageConfigPaths: [
'./node_modules/*/package.json',
"./node_modules/@mescius/*/package.json",
"./node_modules/@babel/*/package.json",
"./node_modules/@vue/*/package.json"
],
map: {
'@mescius/spread-sheets': 'cdn:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-shapes': 'cdn:@mescius/spread-sheets-shapes/index.js',
'@mescius/spread-sheets-slicers': 'cdn:@mescius/spread-sheets-slicers/index.js',
'@mescius/spread-sheets-vue': 'cdn:@mescius/spread-sheets-vue/index.js',
'vue': "npm:vue/dist/vue.esm-browser.js",
'tiny-emitter': 'npm:tiny-emitter/index.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
"systemjs-babel-build": "npm:systemjs-plugin-babel/systemjs-babel-browser.js",
},
meta: {
'*.css': { loader: 'systemjs-plugin-css' },
'*.vue': { loader: "../plugin-vue/index.js" }
}
});
})(this);